﻿var selectedIds = [];
emptyMsgJqOperatorGroupsAccessToCustomerGroupsDiv = $("<div style='padding:5px;' class='hidden'><span>Neexistuje žádný záznam</span></div>");

$(document).ready(function () {
    $("#dialogOperatorGroupsAccessToCustomerGroupsAdd").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: "700",
        buttons: [{
            text: Localization_Add,
            click: function () {
                OnAjaxBegin();
                $.post(
                    RQ_URL + "/Admin/OperatorGroupsAccessToCustomerGroups/AddAccessOperatorGroupsToCustomerGroups",
                    {
                        operatorGroups: $("#dialogOperatorGroupsAccessToCustomerGroupsOperatorGroups").val(),
                        customerGroups: $("#dialogOperatorGroupsAccessToCustomerGroupsCustomerGroups").val(),
                    },
                    "json")
                    .error(function (error) { alert(error.responseText); })
                    .success(function () {
                        OnAjaxComplete();
                        $("#jqOperatorGroupsAccessToCustomerGroups").trigger("reloadGrid");
                        $("#dialogOperatorGroupsAccessToCustomerGroupsAdd").dialog("close");
                    });
            }
        },
        {
            text: Localization_Cancel,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#btOperatorGroupsAccessToCustomerGroupsAll").click(function () {
        setClassesOnButtons("#btOperatorGroupsAccessToCustomerGroupsAll", "#btOperatorGroupsAccessToCustomerGroupsListed");
        setRestrictOperatorsAccessToCustomers(false);
        $("#divOperatorGroupsAccessToCustomerGroupsListed").hide();
    });

    $("#btOperatorGroupsAccessToCustomerGroupsListed").click(function () {
        setClassesOnButtons("#btOperatorGroupsAccessToCustomerGroupsListed", "#btOperatorGroupsAccessToCustomerGroupsAll");
        setRestrictOperatorsAccessToCustomers(true);
        $("#divOperatorGroupsAccessToCustomerGroupsListed").show();
    });

    $("#jqOperatorGroupsAccessToCustomerGroups").jqGrid({
        url: RQ_URL + '/Admin/OperatorGroupsAccessToCustomerGroups/OperatorGroupsAccessToCustomerGroupsData',
        mtype: "GET",
        styleUI: 'Bootstrap',
        datatype: "json",
        colModel: [
            { name: 'Id', hidden: true, key: true }, //this id gets onSelectRow/All
            { label: 'Operátorská skupina', name: 'OperatorGroupName', width: 170, index: 'OperatorGroup.Name', search: true, formatter: operatorGroupsFormat },
            { label: 'Skupina společností', name: 'CustomerGroupName', width: 170, index: 'CustomerGroup.Name', search: true, formatter: customerGroupsFormat },
            { label: 'Pouze nahlížení', name: 'OnlyView', width: 140, fixed: true, index: 'OnlyView', search: false, formatter: onlyViewFormat },
            {
                label: Localization_Actions,
                name: "actions",
                sortable: false,
                formatter: myActions,
                search: false,
                fixed: true,
                title: false,
                width: 70
            },
        ],
        width: 1400,
        sortname: 'CustomerGroup.Name',
        viewrecords: true,
        multiselect: true,
        height: 'auto',
        rowNum: 20,
        scrollOffset: 0,
        rowList: [10, 20, 50, 100],
        onSelectRow: function (id, isSelected) {
            SelectRowEvent(id, isSelected);
        },
        onSelectAll: function (id, isSelected) {
            for (i = 0; i < id.length; i++) {
                SelectRowEvent(id[i], isSelected)
            }
        },
        loadComplete: function (data) {
            initBsTooltip();
            var ts = this;
            if (ts.p.reccount === 0) {
                $(this).hide();
                emptyMsgJqOperatorGroupsAccessToCustomerGroupsDiv.show();
            } else {
                $(this).show();
                emptyMsgJqOperatorGroupsAccessToCustomerGroupsDiv.hide();
            }
        },
        pager: "#jqOperatorGroupsAccessToCustomerGroupsPager",
    });

    emptyMsgJqOperatorGroupsAccessToCustomerGroupsDiv.insertAfter($("#jqOperatorGroupsAccessToCustomerGroups").parent());

    $('#jqOperatorGroupsAccessToCustomerGroups').jqGrid().setGridParam(
        {
            gridComplete: function () {
                $(".deleteLink").click(function (e) {
                    e.preventDefault();
                    var targetUrl = $(this).attr("href");

                    $("#dialog-confirm").dialog({
                        buttons: {
                            "Ano": function () {
                                window.location.href = targetUrl;
                            },
                            "Ne": function () {
                                $(this).dialog("close");
                            }
                        }
                    });

                    $("#dialog-confirm").dialog("open");
                });

            },

        });

    $('#jqOperatorGroupsAccessToCustomerGroups').jqGrid('filterToolbar');
    $('#jqOperatorGroupsAccessToCustomerGroups').jqGrid('navGrid', "#jqOperatorGroupsAccessToCustomerGroupsPager", {
        search: false, // show search button on the toolbar
        add: false,
        edit: false,
        del: false,
        refresh: true
    });

    $("#dialogOperatorGroupsAccessToCustomerGroupsCustomerGroups").select2({
        width: '100%',
        templateSelection: formatCustomerGroupSelection,
        templateResult: formatCustomerGroupResult,
    })

    $("#dialogOperatorGroupsAccessToCustomerGroupsCustomerGroups").trigger("change");
});

function openOperatorGroupsAccessToCustomerGroupsAddDialog() {
    $("#dialogOperatorGroupsAccessToCustomerGroupsOperatorGroups").val([]).trigger("change");
    $("#dialogOperatorGroupsAccessToCustomerGroupsCustomerGroups").val([]).trigger("change");
    $("#dialogOperatorGroupsAccessToCustomerGroupsAdd").dialog("open");
}

function setClassesOnButtons(primaryElementId, defaultElementId) {
    $(primaryElementId).addClass("btn-primary");
    $(primaryElementId).removeClass("btn-default");
    $(defaultElementId).addClass("btn-default");
    $(defaultElementId).removeClass("btn-primary");
}

function myActions(cellValue, options, rowObject) {
    var actionHtml = "<a class='deleteLink jqgrid-bootstrap-table-delete' data-toggle='tooltip' title='" + Localization_Delete + "' href='" + RQ_URL + "/OperatorGroupsAccessToCustomerGroups/DeleteAccessOperatorGroupToCustomerGroup/" + rowObject.Id + "' ><i class=\"fa fa-trash-o fa-lg\"></i></a>";
    return actionHtml;
}

function setRestrictOperatorsAccessToCustomers(val) {
    $.post(
        RQ_URL + "/Admin/OperatorGroupsAccessToCustomerGroups/SetRestrictOperatorsAccessToCustomers",
        {
            value: val,
        },
        "json")
        .error(function (error) { alert(error.responseText); })
        .success(function () { });
}

function deleteOperatorGroupsAccessToCustomerGroups() {
    OnAjaxBegin();
    $.post(
        RQ_URL + "/Admin/OperatorGroupsAccessToCustomerGroups/DeleteAccessOperatorGroupsToCustomerGroups",
        {
            ids: selectedIds,
        },
        "json")
        .error(function (error) { alert(error.responseText); })
        .success(function () {
            selectedIds = [];
            $('.bulk-actions').prop('disabled', selectedIds.length == 0);
            $("#jqOperatorGroupsAccessToCustomerGroups").trigger("reloadGrid");
            OnAjaxComplete();
        });
}

function SelectRowEvent(id, isSelected) {
    if (isSelected) {
        //item selected, add index to array
        if (selectedIds.indexOf(id) == -1) {
            selectedIds.push(id);
        }
    }
    else {
        //item deselected, remove from array
        var index = selectedIds.indexOf(id)

        if (index != -1) {
            selectedIds.splice(index, 1);
        }
    }
    $('.bulk-actions').prop('disabled', selectedIds.length == 0);
}

function customerGroupsFormat(cellValue, options, rowObject) {
    var html = "";
    if (cellValue != null) {
        html += "<i class='fas fa-object-group' style='color:" + rowObject.CustomerGroupColor + "'></i> <a href='" + RQ_URL + "/Admin/CustomerGroups/Edit/" + rowObject.CustomerGroupId + "'>" + rowObject.CustomerGroupName + "</a>";
    }
    return html;
}

function operatorGroupsFormat(cellValue, options, rowObject) {
    var html = "";
    if (cellValue != null) {
        html += "<i class='fas fa-users' style='color:" + rowObject.OperatorGroupColor + "'></i> <a href='" + RQ_URL + "/OperatorGroups/Edit/" + rowObject.OperatorGroupId + "'>" + rowObject.OperatorGroupName + "</a>";
    }
    return html;
}

function onlyViewFormat(cellValue, options, rowObject) {
    var html = "";
    if (cellValue != null) {
        html += "<input type='checkbox'>";
    }
    return html;
}