﻿/**
    URL adresy se definují na stránce která to používá

    Myšleno jako sdílené akce s požadavkem na více místech.
**/

$(document).ready(function () {
    initActions(); 
});

function initActions() {
    $(".automatic-actions .dropdownlistMultipleValue").select2({ placeholder: Localization_SelectInSelect }).addClass("left");
    $(".automatic-actions .dropdownlistValue").select2({ placeholder: Localization_SelectInSelect }).addClass("left");
    $(".automatic-actions .dropdownlistuserValue").select2({
        minimumInputLength: 0,
        multiple: false,
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    showEmail: true,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    }).addClass("left");
    $(".automatic-actions .dropdownlistuseroperatorValue").select2({
        minimumInputLength: 0,
        multiple: false,
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    showEmail: true,
                    includeEndUsers: false,
                    includeSmartUsers: false,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    }).addClass("left");
    $(".automatic-actions .action-type").select2({ width: 450, dropdownAutoWidth: true });
    $(".automatic-actions .all-checkbox").change(function () {
        $(this).closest(".action-for-automation-event").find(".everybodyCanSee").val($(this).is(":checked"));
        if ($(this).is(":checked")) {
            $(this).closest(".action-for-automation-event").find(".only-user-select").hide();
        }
        else {
            $(this).closest(".action-for-automation-event").find(".only-user-select").show();
        }
    });
    $(".automatic-actions").on("change", ".js-requestSpecialHeader", function () {
        $(this).closest(".form-group").find(".js-requestSpecialHeaderValue").val($(this).is(":checked"));
        if ($(this).is(":checked")) {
            $(this).closest(".form-group").find(".js-headerBox").show();
        }
        else {
            $(this).closest(".form-group").find(".js-headerBox").hide();
        }
    });
    $(".automatic-actions").on("change", ".js-requestAuthentication", function () {
        $(this).closest(".form-group").find(".js-requestAuthenticationValue").val($(this).is(":checked"));
        if ($(this).is(":checked")) {
            $(this).closest(".form-group").find(".js-authenticationBox").show();
        }
        else {
            $(this).closest(".form-group").find(".js-authenticationBox").hide();
        }
    });
    $(".automatic-actions .all-checkbox").trigger("change");
    $(".automatic-actions .userValue ").select2({
        minimumInputLength: 0,
        multiple: false,
        width: '100%',
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    showEmail: true,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });
    $.each($('.colorValue'), function (index, value) {
        var colorValue = $(value).val();
        $(value).closest('.change-color').initColorpicker();
        $(value).closest('.change-color').colorpicker('setValue', colorValue);
    });
    if ($(".automatic-actions div.tinymce-inline").length > 0) {
        tinymce.init({
            selector: ".automatic-actions div.tinymce-inline",
            cache_suffix: "?ver=" + ver,
            theme: "modern",
            plugins: [
                "autoresize advlist autolink lists link image charmap print preview anchor",
                "searchreplace visualblocks code fullscreen",
                "insertdatetime media table contextmenu paste textcolor"
            ],
            toolbar1: "insertfile undo redo | styleselect | bold italic | forecolor backcolor | link image",
            toolbar2: "alignleft aligncenter alignright alignjustify | bullist numlist outdent indent",
            entity_encoding: "raw",
            convert_fonts_to_spans: true,
            paste_data_images: true,
            language: language,
            branding: false,
            inline: true,
            setup: function (editor) {
                editor.on('change', function (e) {
                    $(tinymce.activeEditor.selection.getNode()).closest(".form-group").find(".textValue").val(editor.getContent());
                });
            }
        });
    }
    $(".automatic-actions .select2-user").select2({
        placeholder: Localization_Search,
        minimumInputLength: 0,
        allowClear: false,
        multiple: true,
        tags: true,
        /*width: 'auto',*/
        dropdownAutoWidth: true,
        tokenSeparators: [',', ';', ' '],
        createTag: function (tag) { //pro vlastni tagy
            if (isValidEmailAddress(tag.term)) { //kontrola validni email adresy
                return {
                    id: tag.term,
                    text: tag.term
                };
            }
            else return null;
        },
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    showEmail: true,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                if (data.PageNum == 1) {
                    $(specialSendToValues).each(function () {
                        data.Results.unshift({ id: this.Value, text: this.Text });
                    });
                }

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });
    $(".automatic-actions .select2-for-actions").select2({ placeholder: Localization_SelectInSelect }).addClass("left");
    $($(".automatic-actions").find(".dropdownlistMultipleValue")).each(function (index, value) {
        $(value).val(($(value).closest("div").find(".conditionDefaultValue").val() + "").split(",")).trigger("change");
    });
    $($(".automatic-actions").find(".userEmail")).each(function (index, value) {
        $(value).val(($(value).closest("div").find(".conditionDefaultValue").val() + "").split(",")).trigger("change");
    });

    $(".automatic-actions").sortable({
        handle: ".handle",
    });


}


function addNewAction() {
    $(newActionButton).hide();
    $(".automatic-actions").append($("#NewRowForAutomationAction").html());
    
    $(".automatic-actions").sortable({
        handle: ".handle",
    });

    $.ajax({
        url: RQ_URL + getActionListForSelect2,
        data: { areaType: $('#ddlAreaType').val() },
        context: document.body,
        async: false
    }).done(function (data) {
        var options = createActionOptions(data);
        $(".automatic-actions").find(".action-type").last().append(options);
        $(".automatic-actions").find(".action-type").last().select2({ dropdownAutoWidth: true }); //reinit sirky (kvuli options)
        $(".automatic-actions").find(".action-type").last().val("-1").trigger("change");
    })
    .error(function (error) {
        alert(error.responseText);
    });
}

function createActionOptions(fields) {
    var currentGroupKey;
    var groupOpened = false;
    var options = "<option value='-1'>" + Localization_SelectInSelect + "</option>";

    for (var j = 0; j < fields.length; j++) {
        if (currentGroupKey != fields[j].GroupKey) {
            currentGroupKey = fields[j].GroupKey;

            if (groupOpened) {
                options += "</optgroup>";
            }

            options += '<optgroup label="' + fields[j].GroupName + '" value="' + fields[j].GroupKey + '">';
            groupOpened = true;
        }
        var htmlattributes = "";
        $(fields[j].HtmlAttributes).each(function () {
            htmlattributes += " " + this.Name + "='" + this.Value + "'";
        });

        options += "<option value='" + fields[j].Value + "'" + htmlattributes + ">" + fields[j].Text + "</option>";
    }
    if (groupOpened) {
        options += "</optgroup>";
    }
    return options;
}

function actionFieldChanged($rootElement) {
    var options = "";
    $element = $rootElement.find("> .action-select");
    var actionId = $element.find("> .action-type").val();
    var priorityId = $element.find("> .action-type option:selected").data('priorityid');
    var categoryId = $element.find("> .action-type option:selected").data('categoryid');

    if (actionId == -1) {
        $rootElement.find("> .value, > span > .value").remove();
        $rootElement.find("> .priority-label").remove();
    }
    else {
        options = "";

        $.ajax({
            url: RQ_URL + getActionValueTypeAndOptions + "?automationEventAction=" + actionId + "&priorityId=" + priorityId + "&categoryId=" + categoryId,
            context: document.body,
            async: false
        }).done(function (data) {
            if ($rootElement.find("> .value").data('select2')) {
                $rootElement.find("> .value:data(select2)").select2('destroy');
            }

            $rootElement.find("> .value, > span > .value").remove();
            $rootElement.find("> .priority-label").remove();
            var operator_ddl = $element;
            adjustActionFields(operator_ddl, data, null, null, priorityId, categoryId);
        })
        .error(function (error) {
            alert(error.responseText);
        });
    }
}

var specialSendToValues = new Array();
specialSendToValues.push({ Text: "(zadavatel požadavku)", Value: "TICKET_SUBMITTER" });
specialSendToValues.push({ Text: "(řešitel požadavku)", Value: "TICKET_SOLVER" });
specialSendToValues.push({ Text: "(manažer požadavku)", Value: "TICKET_MANAGER" });

function adjustActionFields(operator_ddl, data, i, index, priorityId, categoryId) {
    if (priorityId == undefined)
        priorityId = "";

    if (categoryId == undefined)
        categoryId = "";

    operator_ddl.after('<input type="hidden" class="left text value fieldType" value="' + data.Type + '" />');
    operator_ddl.after('<input type="hidden" class="left text value priorityId" value="' + priorityId + '" />');
    operator_ddl.after('<input type="hidden" class="left text value categoryId" value="' + categoryId + '" />');

    if (data.Type == "textbox") {
        operator_ddl.after('<input type="text" class="left text value textValue" />');
    }
    else if (data.Type == "textarea") {
        operator_ddl.closest(".action-for-automation-event").find("> .buttons").after('<div class="add-textarea value clear"><textarea class="textarea textareaValue" /></div>');
    }
    else if (data.Type == "addnote") {
        operator_ddl.closest(".action-for-automation-event").find("> .buttons").after("<div class='add-note value clear' style='padding-top:5px;'>" + $("#AutomationActionAddNoteTemplate").html() + "</div>");
        operator_ddl.closest(".action-for-automation-event").find(".all-checkbox").change(function () {
            $(this).closest(".action-for-automation-event").find(".everybodyCanSee").val($(this).is(":checked"));
            if ($(this).is(":checked")) {
                operator_ddl.closest(".action-for-automation-event").find(".only-user-select").hide();
            }
            else {
                operator_ddl.closest(".action-for-automation-event").find(".only-user-select").show();
            }
        });
        operator_ddl.closest(".action-for-automation-event").find(".all-checkbox").trigger("change");
        operator_ddl.closest(".action-for-automation-event").find(".select-user").select2({
            minimumInputLength: 0,
            multiple: false,
            width: '100%',
            placeholder: Localization_Search,
            ajax: {
                url: RQ_URL + '/Account/UsersForSelect2Ajax',
                type: "POST",
                dataType: 'json',
                delay: 250,
                data: function (params) {
                    return {
                        pageSize: 10,
                        pageNum: params.page || 1,
                        term: params.term,
                        showEmail: true,
                    };
                },
                processResults: function (data, params) {
                    params.page = data.PageNum;

                    return {
                        results: data.Results,
                        pagination: {
                            more: (data.PageNum * data.PageSize) < data.Total
                        }
                    };
                },
                cache: true,
            },
            escapeMarkup: function (markup) { return markup; },
            templateResult: formatUsersForSelect2AjaxData,
            templateSelection: formatUsersForSelect2AjaxElement,
        });
        $('.change-color').initColorpicker();
    }
    else if (data.Type == "webhook") {
        operator_ddl.closest(".action-for-automation-event").find("> .buttons").after("<div class='webhook value clear' style='padding-top:5px;'><div id='place-webhook-template-here'></div></div>");
        $('#place-webhook-template-here').parent().load(RQ_URL + "/Admin/AutomationEvents/LoadWebhookPartial", { area: $('#ddlAreaType').val() });
    }
    else if (data.Type == "email") {
        operator_ddl.closest(".action-for-automation-event").find("> .buttons").after("<div class='email-body value clear' style='padding-top:5px;'>" + $("#AutomationActionEmailTemplate").html() + "</div>");
        tinymce.init({
            selector: ".automatic-actions div.tinymce-inline",
            cache_suffix: "?ver=" + ver,
            theme: "modern",
            plugins: [
                "autoresize advlist autolink lists link image charmap print preview anchor",
                "searchreplace visualblocks code fullscreen",
                "insertdatetime media table contextmenu paste textcolor"
            ],
            toolbar1: "insertfile undo redo | styleselect | bold italic | forecolor backcolor | link image",
            toolbar2: "alignleft aligncenter alignright alignjustify | bullist numlist outdent indent",
            entity_encoding: "raw",
            convert_fonts_to_spans: true,
            paste_data_images: true,
            language: language,
            inline: true,
            setup: function (editor) {
                editor.on('change', function (e) {
                    $(operator_ddl).closest(".action-for-automation-event").find(".textValue").val(editor.getContent());
                });
            }
        });
        operator_ddl.closest(".action-for-automation-event").find(".select2-user").select2({
            placeholder: "Hledat ...",
            minimumInputLength: 0,
            allowClear: false,
            multiple: true,
            tags: true,
            /*width: 'auto',*/
            dropdownAutoWidth: true,
            tokenSeparators: [',', ';', ' '],
            createTag: function (tag) { //pro vlastni tagy
                if (isValidEmailAddress(tag.term)) { //kontrola validni email adresy
                    return {
                        id: tag.term,
                        text: tag.term
                    };
                }
                else return null;
            },
            ajax: {
                url: RQ_URL + '/Account/UsersForSelect2Ajax',
                type: "POST",
                dataType: 'json',
                delay: 250,
                data: function (params) {
                    return {
                        pageSize: 10,
                        pageNum: params.page || 1,
                        term: params.term,
                        showEmail: true,
                    };
                },
                processResults: function (data, params) {
                    params.page = data.PageNum;

                    if (data.PageNum == 1) {
                        $(specialSendToValues).each(function () {
                            data.Results.unshift({ id: this.Value, text: this.Text });
                        });
                    }

                    return {
                        results: data.Results,
                        pagination: {
                            more: (data.PageNum * data.PageSize) < data.Total
                        }
                    };
                },
                cache: true,
            },
            escapeMarkup: function (markup) { return markup; },
            templateResult: formatUsersForSelect2AjaxData,
            templateSelection: formatUsersForSelect2AjaxElement,
        });
    }
    else if (data.Type == "priority") {
        var dropdown = $('<select class="select2-for-actions value left priorityImpactValue" style="min-width:200px;"></select>');
        operator_ddl.after(dropdown);
        operator_ddl.after('<div class="left margin-right-small priority-label">Dopad</div>');

        var options;
        $(data.Options).each(function () {
            options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
        });
        dropdown.html(options);
        dropdown.select2({ placeholder: Localization_SelectInSelect }).addClass("left");

        var dropdown2 = $('<select class="select2-for-actions value left priorityUrgencyValue" style="min-width:200px;"></select>');
        operator_ddl.after(dropdown2);
        operator_ddl.after('<div class="left margin-right-small priority-label">Naléhavost</div>');

        options = "";
        $(data.Urgency).each(function () {
            options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
        });
        dropdown2.html(options);
        dropdown2.select2({ placeholder: Localization_SelectInSelect }).addClass("left");
    }
    else if (data.Type == "dropdownlistmultiple") {
        var dropdown = $('<select class="select2-for-actions value left dropdownlistMultipleValue" multiple="multiple" style="min-width:200px;"></select>');
        operator_ddl.after(dropdown);

        var options;
        $(data.Options).each(function () {
            options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
        });
        dropdown.html(options);
        dropdown.select2({ placeholder: Localization_SelectInSelect }).addClass("left");
    }
    else if (data.Type == "dropdownlist") {
        var dropdown = $('<select class="select2-for-actions value left dropdownlistValue" style="min-width:200px;"></select>');
        operator_ddl.after(dropdown);

        var options;
        $(data.Options).each(function () {
            options += "<option " + (this.Disabled ? "disabled" : "") + " value='" + this.Value + "'>" + this.Text + "</option>";
        });
        dropdown.html(options);
        dropdown.select2({ placeholder: Localization_SelectInSelect }).addClass("left");
    }
    else if (data.Type == "dropdownlistuser") {
        $dropdown = $('<select class="select2-for-views value left dropdownlistuserValue" style="min-width:200px;"></select>');
        operator_ddl.after($dropdown);
        $dropdown.select2({
            minimumInputLength: 0,
            multiple: false,
            placeholder: Localization_Search,
            ajax: {
                url: RQ_URL + '/Account/UsersForSelect2Ajax',
                type: "POST",
                dataType: 'json',
                delay: 250,
                data: function (params) {
                    return {
                        pageSize: 10,
                        pageNum: params.page || 1,
                        term: params.term,
                        showEmail: true,
                    };
                },
                processResults: function (data, params) {
                    params.page = data.PageNum;

                    return {
                        results: data.Results,
                        pagination: {
                            more: (data.PageNum * data.PageSize) < data.Total
                        }
                    };
                },
                cache: true,
            },
            escapeMarkup: function (markup) { return markup; },
            templateResult: formatUsersForSelect2AjaxData,
            templateSelection: formatUsersForSelect2AjaxElement,
        }).addClass("left");
    }
    else if (data.Type == "dropdownlistuseroperator") {
        $dropdown = $('<select class="select2-for-views value left dropdownlistuseroperatorValue" style="min-width:200px;"></select>');
        operator_ddl.after($dropdown);
        $dropdown.select2({
            minimumInputLength: 0,
            multiple: false,
            placeholder: Localization_Search,
            ajax: {
                url: RQ_URL + '/Account/UsersForSelect2Ajax',
                type: "POST",
                dataType: 'json',
                delay: 250,
                data: function (params) {
                    return {
                        pageSize: 10,
                        pageNum: params.page || 1,
                        term: params.term,
                        showEmail: true,
                        includeEndUsers: false,
                        includeSmartUsers: false,
                    };
                },
                processResults: function (data, params) {
                    params.page = data.PageNum;

                    return {
                        results: data.Results,
                        pagination: {
                            more: (data.PageNum * data.PageSize) < data.Total
                        }
                    };
                },
                cache: true,
            },
            escapeMarkup: function (markup) { return markup; },
            templateResult: formatUsersForSelect2AjaxData,
            templateSelection: formatUsersForSelect2AjaxElement,
        }).addClass("left");
    }
    else if (data.Type == "nothing") {
        //není potřeba dělat nic
    }
}

function getActionData(actions) {
    var actions = $(".automatic-actions").children(".action-for-automation-event");
    var data = [];

    for (var i = 0; i < actions.length; i++) {
        var dt = {
            FieldType: $(actions[i]).find("select.action-type").val(),
            PriorityId: $(actions[i]).find(".priorityId").val(),
            CategoryId: $(actions[i]).find(".categoryId").val()
        };
        if ($(actions[i]).find(".fieldType").val() == "textbox") {
            dt.TextValue = $(actions[i]).find(".textValue").val();
        }
        else if ($(actions[i]).find(".fieldType").val() == "textarea") {
            dt.TextValue = $(actions[i]).find(".textareaValue").val();
        }
        else if ($(actions[i]).find(".fieldType").val() == "addnote") {
            dt.TextValue = $(actions[i]).find(".textValue").val();
            dt.ColorValue = $(actions[i]).find(".colorValue").val();
            dt.EverybodyCanSee = $(actions[i]).find(".everybodyCanSee").is(":checked");
            dt.UserProviderKey = $(actions[i]).find(".userValue").val();
        }
        else if ($(actions[i]).find(".fieldType").val() == "email") {
            dt.TextValue = $(actions[i]).find(".textValue").val();
            dt.SubjectValue = $(actions[i]).find(".subjectValue").val();
            dt.Emails = $(actions[i]).find(".userEmail").val();
        }
        else if ($(actions[i]).find(".fieldType").val() == "priority") {
            dt.PriorityImpactValue = $(actions[i]).find(".priorityImpactValue").val();
            dt.PriorityUrgencyValue = $(actions[i]).find(".priorityUrgencyValue").val();
        }
        else if ($(actions[i]).find(".fieldType").val() == "dropdownlistmultiple") {
            dt.SelectedMultipleValues = $(actions[i]).find(".dropdownlistMultipleValue").val();
        }
        else if ($(actions[i]).find(".fieldType").val() == "dropdownlist") {
            dt.SelectedValue = $(actions[i]).find(".dropdownlistValue").val();
        }
        else if ($(actions[i]).find(".fieldType").val() == "dropdownlistuser") {
            dt.UserProviderKey = $(actions[i]).find(".dropdownlistuserValue").val();
        }
        else if ($(actions[i]).find(".fieldType").val() == "dropdownlistuseroperator") {
            dt.UserProviderKey = $(actions[i]).find(".dropdownlistuseroperatorValue").val();
        }
        else if ($(actions[i]).find(".fieldType").val() == "nothing") {
        }
        data.push(dt);
    }
    return data;
}

function renameActions() {
    var actions = $(".automatic-actions").children(".action-for-automation-event");

    var name = "Actions";
    for (var i = 0; i < actions.length; i++) {
        $(actions[i]).find("select.action-type").attr("name", name + "[" + i + "].AutomationEventAction");
        $(actions[i]).find(".priorityId").attr("name", name + "[" + i + "].PriorityId");
        $(actions[i]).find(".categoryId").attr("name", name + "[" + i + "].CategoryId");

        $(actions[i]).find(".textValue").attr("name", name + "[" + i + "].TextValue");
        $(actions[i]).find(".textareaValue").attr("name", name + "[" + i + "].TextareaValue");
        $(actions[i]).find(".colorValue").attr("name", name + "[" + i + "].ColorValue");
        $(actions[i]).find(".everybodyCanSee").attr("name", name + "[" + i + "].EverybodyCanSee");
        $(actions[i]).find(".userValue").attr("name", name + "[" + i + "].UserProviderKey");
        $(actions[i]).find(".subjectValue").attr("name", name + "[" + i + "].SubjectValue");
        $(actions[i]).find(".userEmail").attr("name", name + "[" + i + "].Emails");
        $(actions[i]).find(".js-urlValue").attr("name", name + "[" + i + "].UrlValue");
        $(actions[i]).find(".js-requestSpecialHeaderValue").attr("name", name + "[" + i + "].SpecialHeader");
        $(actions[i]).find(".js-requestHeader").attr("name", name + "[" + i + "].Header");
        $(actions[i]).find(".js-requestPassword").attr("name", name + "[" + i + "].Password");
        $(actions[i]).find(".js-requestUserName").attr("name", name + "[" + i + "].UserName");
        $(actions[i]).find(".js-requestAuthenticationValue").attr("name", name + "[" + i + "].Authentication");
        $(actions[i]).find(".js-requestContentTypeValue:checked").attr("name", name + "[" + i + "].RequestContentType");
        $(actions[i]).find(".js-requestFormatMethod:checked").attr("name", name + "[" + i + "].RequestFormatMethod");
        $(actions[i]).find(".priorityImpactValue").attr("name", name + "[" + i + "].PriorityImpactValue");
        $(actions[i]).find(".priorityUrgencyValue").attr("name", name + "[" + i + "].PriorityUrgencyValue");
        $(actions[i]).find(".dropdownlistMultipleValue").attr("name", name + "[" + i + "].SelectedMultipleValues");
        $(actions[i]).find(".dropdownlistValue").attr("name", name + "[" + i + "].SelectedValue");
        $(actions[i]).find(".dropdownlistuserValue").attr("name", name + "[" + i + "].UserProviderKey");
        $(actions[i]).find(".dropdownlistuseroperatorValue").attr("name", name + "[" + i + "].UserProviderKey");
        $(actions[i]).find(".js-denyIfApi").attr("name", name + "[" + i + "].DenyIfApi");
    }
}

function AreActionsValid() {
    var actions = $(".automatic-actions").children(".action-for-automation-event");
    var result = true;

    for (var i = 0; i < actions.length; i++) {
        if ($(actions[i]).find(".action-type").val() == "-1") {
            result = false;
        }

        if ($(actions[i]).find(".fieldType").val() == "textbox") {
            if ($(actions[i]).find(".textValue").val() == "" || $(actions[i]).find(".textValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "textarea") {
            if ($(actions[i]).find(".textareaValue").val() == "" || $(actions[i]).find(".textareaValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "addnote") {
            if ($(actions[i]).find(".textValue").val() == "" || $(actions[i]).find(".textValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "email") {
            if ($(actions[i]).find(".textValue").val() == "" || $(actions[i]).find(".textValue").val() == null || $(actions[i]).find(".userEmail").val() == null ||
                $(actions[i]).find(".subjectValue").val() == "" || $(actions[i]).find(".subjectValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "webhook") {
            if (($(actions[i]).find(".js-urlValue").val() == "" || $(actions[i]).find(".js-urlValue").val() == null) && ($(actions[i]).find(".js-requestPassword").val().length + $(actions[i]).find(".js-requestUserName").val().length + 1 > 255)) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "priority") {
            if ($(actions[i]).find(".priorityImpactValue").val() == null || $(actions[i]).find(".priorityUrgencyValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "dropdownlistmultiple") {
            if ($(actions[i]).find(".dropdownlistMultipleValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "dropdownlist") {
            if ($(actions[i]).find(".dropdownlistValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "dropdownlistuser") {
            if ($(actions[i]).find(".dropdownlistuserValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "dropdownlistuseroperator") {
            if ($(actions[i]).find(".dropdownlistuseroperatorValue").val() == null) {
                result = false;
            }
        }
        else if ($(actions[i]).find(".fieldType").val() == "nothing") {
            //není potřeba dělat nic
        }


        $(actions[i]).find(".valid-error").toggle(!result);
    }

    return result;
}

var closingColorPicker = false;

$.fn.initColorpicker = function () {
    $(this).colorpicker({
        colorSelectors: {
            'stickynote': '#ffffcc',
            'orange': '#f0ad4e',
            'green': '#5cb85c',
            'lightblue': '#5bc0de',
            'darkblue': '#337ab7',
            'lightred': '#d9534f',
            'darkred': '#b90600',
            'pink': '#ec2b8c',
            'purple': '#763f98',
            'default': '#7f7f7f',
            'chocolate': '#7B3F00',
        }
    })
    .on('changeColor', function (event) {
        var color = event.color;
        color.a = '0.9';
        $(this).closest(".ticket-sticky-note").css('background-color', color.toHex());
    })
    .on('hidePicker', function (event) {
        if (!closingColorPicker) { //hack to prevent calling this twice, maybe colorpicker bug

            closingColorPicker = true;
        }
    });
}

function resetActions() {
    $('.automatic-actions').empty();
    $('.btn-new-automation-action').show();
}