﻿$(document).ready(function () {
    $("#Dialog-delete").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 'auto',
        buttons: [{
            text:Localization_Yes,
            click: function () {
                $.ajax({
                    url: RQ_URL + "/CompanyOrganization/Delete",
                    type: "POST",
                    data: JSON.stringify({
                        Id: workPositionId,
                    }),
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    success: function (g) {
                        reloadTree();
                        if (g.Type == DEPARTMENT) {
                            ShowSuccess(Localization_CompanyOrganization_Department + ' "' + g.Title + '" ' + Localization_CompanyOrganization_WasDeleted);
                        }
                        else {
                            ShowSuccess(Localization_CompanyOrganization_WorkPosition + ' "' + g.Title + '" ' + Localization_CompanyOrganization_WasDeleted);
                        }
                        $("#Dialog-delete").dialog("close");
                    },
                    error: function (error) { alert(error.responseText); },
                    complete: function () {
                    }
                });
            }},{
                text: Localization_No,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#Dialog-delete-department").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 'auto',
        buttons: [{
            text: Localization_Yes,
            click: function () {
                $.ajax({
                    url: RQ_URL + "/CompanyOrganization/Delete",
                    type: "POST",
                    data: JSON.stringify({
                        Id: workPositionId,
                    }),
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    success: function (g) {
                        reloadTree();
                        if (g.Type == DEPARTMENT) {
                            ShowSuccess(Localization_CompanyOrganization_Department + ' "' + g.Title + '" ' + Localization_CompanyOrganization_WasDeleted);
                        }
                        else {
                            ShowSuccess(Localization_CompanyOrganization_WorkPosition +' "' + g.Title + '" byla smazána.');
                        }
                        $("#Dialog-delete-department").dialog("close");
                    },
                    error: function (error) { alert(error.responseText); },
                    complete: function () {
                    }
                });
            }
        }, {
            text: Localization_No,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#Dialog-companyOrganization").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 'auto',
        titleIsHtml: true,
        buttons:[
        {
            id: "saveButton",
            text: Localization_Save,
            click: function () {
                if ($("#DialogCompanyOrganizationName").val() == "") {
                    $("#DialogCompanyOrganizationNameError").show();
                }
                else {
                    $.ajax({
                        url: RQ_URL + "/CompanyOrganization/AddOrUpdateWorkPosition",
                        type: "POST",
                        data: JSON.stringify({
                            Id: $("#DialogCompanyOrganizationId").val(),
                            Title: $("#DialogCompanyOrganizationName").val(),
                            ParentId: $("#DialogCompanyOrganizationParentWorkPosition").val(),
                            Description: $("#DialogCompanyOrganizationDescription").val(),
                            Users: $("#DialogCompanyOrganizationUsers").val(),
                            Type: $("#DialogCompanyOrganizationType").val(),
                            Edit: editDialog,
                        }),
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        success: function (g) {
                            reloadTree();
                            if (g.Type == WORKPOSITION) {
                                if (g.Edit) {
                                    ShowSuccess(Localization_CompanyOrganization_WorkPosition + ' "' + g.Title + '" ' + Localization_CompanyOrganization_WasUpdated);
                                }
                                else {
                                    ShowSuccess(Localization_CompanyOrganization_WorkPosition + ' "' + g.Title + '" ' + Localization_CompanyOrganization_WasAdded);
                                }
                            }
                            else {
                                if (g.Edit) {
                                    ShowSuccess(Localization_CompanyOrganization_Department + ' "' + g.Title + '" ' + Localization_CompanyOrganization_WasUpdated);
                                }
                                else {
                                    ShowSuccess(Localization_CompanyOrganization_Department + ' "' + g.Title + '" ' + Localization_CompanyOrganization_WasAdded);
                                }
                            }
                            $("#Dialog-companyOrganization").dialog("close");
                        },
                        error: function (error) { alert(error.responseText); },
                        complete: function () {
                        }
                    });
                }
            }
        },
        {
            id: "closeButton",
            text: Localization_Close,
            click: function () {
                $(this).dialog("close");
            }
        }]
            
    });
});

var workPositionId = -1;
var editDialog = false;

function dialogDelete(id, type) {
    workPositionId = id;
    if (type == DEPARTMENT) {
        $("#Dialog-delete-department").dialog("open");
    }
    else {
        $("#Dialog-delete").dialog("open");
    }
}

function reloadTree() {
    OnAjaxBegin("Načítám strom...");
    $("#PartialTreeView").empty();
    $("#PartialTreeView").load(RQ_URL + "/CompanyOrganization/ReloadTree", function () {
        OnAjaxComplete();
    });
}

function dialogEditWorkPosition(id, type) {
    showDialogForManageCompanyOrganization(RQ_URL + "/CompanyOrganization/DialogCompanyOrganization/" + id + "?type=" + type, type, true, null);
}

function dialogNewWorkPosition(type) {
    showDialogForManageCompanyOrganization(RQ_URL + "/CompanyOrganization/DialogCompanyOrganization/null?type=" + type, type, false, null);
}

function dialogNewWorkPositionWithId(id, type) {
    showDialogForManageCompanyOrganization(RQ_URL + "/CompanyOrganization/DialogCompanyOrganization/null?type=" + type, type, false, id);
}

function showDialogForManageCompanyOrganization(url, type, edit, preparedId) {
    OnAjaxBegin(Localization_CompanyOrganization_LoadingDialog);
    $("#DialogWorkPositionNameError").hide();
    $("#Dialog-companyOrganization").load(url, function () {
        editDialog = edit;
        if (preparedId != null)
        {
            $("#DialogCompanyOrganizationParentWorkPosition").val(preparedId).trigger("change");
        }
        if (edit) {
            $('#saveButton').button('option', 'label', Localization_Save);
            if (type == DEPARTMENT) {
                $("#Dialog-companyOrganization").dialog('option', 'title', Localization_Edit);
            }
            else {
                $("#Dialog-companyOrganization").dialog('option', 'title', Localization_Edit);
            }
        }
        else {
            $('#saveButton').button('option', 'label', Localization_Create);
            if (type == DEPARTMENT) {
                $("#Dialog-companyOrganization").dialog('option', 'title', Localization_New);
            }
            else {
                $("#Dialog-companyOrganization").dialog('option', 'title', Localization_New2);
            }
        }
        $("#Dialog-companyOrganization").dialog("open");
        OnAjaxComplete();
    });
}


function formatState(state) {
    if (!state.id) { return state.text; }
    for (var i = 0 ; i < organizationAndType.length; i++) {
        if (organizationAndType[i].Id == state.id) {
            var rest = "";
            var last = state.text;
            while (last[0] == '\xa0')
            {
                rest += "&nbsp;";
                last = last.substring(1, last.length);
            }
            if (organizationAndType[i].Type == DEPARTMENT) {
                var $state = $(
                  '<span>' + rest + '<img src="Content/img/department_12x12.png" class="img-flag" /> ' + last + '</span>'
                );
            }
            else {
                var $state = $(
                  '<span> ' + rest + '<img src="Content/images/work-position_12x12.png" class="img-flag" /> ' + last + '</span>'
                );
            }
            break;
        }
    }
    return $state;
}