﻿$(document).ready(function () {
    reloadTable();

    initSelect2Tags(".searchableTags");

    $("#CustomerNewUserGenerateButton").click(function () {
        $.ajax({
            type: "get",
            url: RQ_URL + '/Account/GeneratePassword',
            dataType: "text",
            success: function (result) {
                $('#CustomerNewUserPassword').val(result);
            }
        });
    });

    $("#dialog-confirmDelete").dialog({
        autoOpen: false,
        modal: true,
        resizable: false
    });

    $("#dialog-upload-icon").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        close: function (event, ui) {
            $("#dialogIcon").val("");
        }
    });

    $("body").on("change", ".ticket-tag-checkbox", function (e) {
        var $element = $(this);
        var userproviderkey = $(this).attr("data-userproviderkey");
        var checked = $(this).is(":checked");
        if (checked)
            $element.closest("tr").find(".ticket-manage-checkbox").removeAttr("disabled");
        else {
            $element.closest("tr").find(".ticket-manage-checkbox").attr("disabled", "disabled");
            $element.closest("tr").find(".ticket-manage-checkbox").removeAttr("checked");
        }
        $.ajax({
            url: RQ_URL + "/Customers/ChangeAccessOthersTickets",
            type: "POST",
            data: JSON.stringify({
                id: customerId,
                userproviderkey: userproviderkey,
                accessotherstickets: checked,
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: function (g) {
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
    });

    $("body").on("change", ".ticket-manage-checkbox", function (e) {
        var userproviderkey = $(this).attr("data-userproviderkey");
        var checked = $(this).is(":checked");
        $.ajax({
            url: RQ_URL + "/Customers/ChangeManageOthersTickets",
            type: "POST",
            data: JSON.stringify({
                id: customerId,
                userproviderkey: userproviderkey,
                accessotherstickets: checked,
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: function (g) {
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
    });

    $("#CustomerEditForm").submit(function () {
        if ($(this).valid()) {
            $(":submit", this).attr("disabled", "disabled");
            $('#pickfiles').css({ visibility: "hidden" });
            //$('#hiddenMessage').val(window.tinyMCE.get('tbMessage').getContent());
            OnAjaxBegin(Localization_SendingPleaseWait);

            if (uploader.files.length > 0) {
                $('div[id^="divFile"] a').hide(); //@*schova [Remove] *@
                if (!filesUploaded) {
                    uploader.start();
                    return false; //@*submitnu az po odeslani souboru *@
                }
            }
            $(":submit", this).removeAttr("disabled");
        }
        else {
            return false; //@*zrusit odeslani validace pokud neprojde explicitni validace*@
        }
    });

    $('.nav-tabs a').click(function (e) {
        e.preventDefault();
        $(this).tab('show');
    })

    $('#btAddExistingUser').click(function (e) {
        $('#ddlCustomerAddExistingUser').val([]).trigger('change');
        $("#dialog-customer-user").dialog("open");
    });

    $('#btAddMessage').click(function (e) {
        e.preventDefault();
        $("#messageId").val(-1);
        window.tinyMCE.get('messageText').setContent("");
        $("#dialog-message").dialog("open");
    });

    $("#messageError").hide();
    $("#dialog-message").dialog({
        autoOpen: false,
        modal: true,
        width: "650px",
        resizable: false,
        buttons: [
            {
                text: Localization_Ok,
                click: function () {
                    var id = $("#messageId").val();
                    var text = window.tinyMCE.get('messageText').getContent();
                    $("#messageError").hide();
                    if (text != "" && text != undefined) {
                        $.ajax({
                            url: RQ_URL + "/Customers/AddDescription",
                            type: "POST",
                            data: JSON.stringify({
                                id: id,
                                text: text,
                                customerId: customerId,
                            }),
                            dataType: "json",
                            contentType: "application/json; charset=utf-8",
                            success: function () {
                                $('#jqGridDescription').trigger("reloadGrid");
                            },
                            error: function (error) { alert(error.responseText); },
                        });
                        $(this).dialog("close");
                    }
                    else {
                        $("#messageError").show();
                    }
                }
            },
            {
                text: Localization_Cancel,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });

    $("#dialog-confirmRemoveUser").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        buttons: [
            {
                text: Localization_Yes,
                click: function () {
                    var id = $("#DeleteUserProviderKey").val();
                    $.ajax({
                        url: RQ_URL + "/Customers/RemoveUserFromAnyCustomer/" + id,
                        type: "GET",
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        success: function () {
                            $(".deleteLink").tooltipBS('hide');
                            $('#jqGrid').trigger("reloadGrid");
                        },
                        error: function (error) { alert(error.responseText); },
                    });
                    $(this).dialog("close");
                }
            },
            {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });

    $("#dialog-confirmDeleteDescription").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        height: 'auto',
        buttons: [{
            text: Localization_Yes,
            click: function() {
                var id = $("#DeleteDescription").val();
                $.ajax({
                    url: RQ_URL + "/Customers/DeleteDescription",
                    type: "POST",
                    data: JSON.stringify({
                        id: id,
                    }),
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    success: function () {
                        $(".deleteLink").tooltipBS('hide');
                        $('#jqGridDescription').trigger("reloadGrid");
                    },
                    error: function (error) { alert(error.responseText); },
                });
                $(this).dialog("close");
            },
        }, {
            text: Localization_No,
            click: function () {
                $(this).dialog("close");
            },
        }]
    });

    $("#dialog-customer-user").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 'auto',
        buttons: [{
            text: Localization_Add,
            click: function () {
                if ($("#ddlCustomerAddExistingUser").val() == null) {
                    $("#lbCustomerAddExistingUserError").show();
                    $("#lbCustomerAddExistingUserError").text("@Html.Raw(LocalResources.Customer.Edit.YouMustChooseUser)");
                }
                else {
                    OnAjaxBegin();
                    $.ajax({
                        url: RQ_URL + "/Account/AddExistingUserToCustomer",
                        type: "POST",
                        data: JSON.stringify({
                            customerId: customerId,
                            userProviderKey: $("#ddlCustomerAddExistingUser").val()
                        }),
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        complete: function (data) {
                            OnAjaxComplete();

                            if (data.responseJSON === true) {
                                $('#jqGrid').trigger("reloadGrid");
                                $("#dialog-customer-user").dialog("close");
                            }
                        },
                        error: function (error) { alert(error.responseText); },
                    });
                }

            }
        }, {
            text: Localization_Cancel,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#ddlCustomerAddExistingUser").select2({
        minimumInputLength: 0,
        multiple: false,
        width: 400,
        placeholder: Localization_ExistingUser,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    exceptCustomerId: customerId,
                    includeOperators: false,
                    showRoleAbbrev: true,
                    showEmail: true,
                    searchInEmail: true,
                    pageNum: params.page || 1,
                    term: params.term,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });

    $("#dialog-user-delete-confirm").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 'auto',
    });
});

function textFormat(cellValue, options, rowObject) {
    return cellValue != "" && cellValue != null ? "<div style='cursor:pointer' onclick='editDescription(" + rowObject.Id + ");' >" + cellValue + "</div>" : "";
}

function emailFormat(cellValue, options, rowObject) {
    return cellValue != "" && cellValue != null ? "<a href='mailto:" + cellValue + "' >" + cellValue + "</a>" : "";
}

function tagFormat(cellValue, options, rowObject) {
    var html = "";
    if (cellValue != null) {
        html += "<div class='ticket-tags'>";
        for (var i = 0; i < cellValue.length; i++) {
            html += "<div class='ticket-tag' style='background-color: " + cellValue[i].BackgroundColor + "; color: " + cellValue[i].TextColor + "; border-color:" + cellValue[i].BorderColor + "'>" + cellValue[i].Name + "</div>";
        }
        html += "</div>";
    }
    else {
        html += "<div></div>";
    }
    return html;
}

var salesForceWasInit = false;

function loadSalesForce() {
    if (!salesForceWasInit) {
        salesForceWasInit = true;
        $("#tab_f").html("<div class='loading-32'></div>")
        $("#tab_f").load(RQ_URL + "/Applications/CustomerSalesForce?customerName=" + encodeURIComponent(customerName), function (response, status, xhr) {
            if (status == "error") {
                alert(response);
            }
        });
    }
}

function formatIsApprovedAndLockedOut(cellValue, options, rowObject) {
    var html = '<i class="fa fa-lg ' + (rowObject.IsApproved ? 'fa-check' : 'fa-times') + '" aria-hidden="true" style="color: ' + (rowObject.IsApproved ? '#4F9F4F' : '#990000;') + ';"></i>' + (rowObject.IsLockedOut ? ' <i class="fa fa-lg fa-lock" aria-hidden="true" style="color: #990000;"></i>' : '');
    return html;
}

function fileNameFormat(cellValue, options, rowObject) {
    return (rowObject.ImageUrl != "" ? "<p><img style='width:32px;height:32px;float:left;margin-right:10px;margin-bottom:5px;' src=" + rowObject.ImageUrl + ">" : "") + "<a href='" + RQ_URL + "/Customers/GetAttachment/" + rowObject.Id + "'>" + cellValue + "</a></p>";
}

function myActionsAttachments(cellValue, options, rowObject) {
    return "<a class='jqgrid-bootstrap-table-delete deleteLink' data-toggle='tooltip' title='" + Localization_Delete + "' href='javascript:DeleteAttachment(\"" + rowObject.Id + "\")' ><i class=\"fa fa-trash-o fa-lg\"></i></a>";
}

function fileSizeFormat(cellValue, options, rowObject) {
    return formatSize(cellValue);
}

function userFullNameFormatter(cellValue, options, rowObject) {
    var nameLinkHtml = "<a href='" + RQ_URL + "/Customers/User/" + rowObject.UserProviderKey + "' >" + cellValue + "</a>";
    return nameLinkHtml;
}

function myActionsDescription(cellValue, options, rowObject) {
    var actionHtml = "<a data-toggle='tooltip' title='" + Localization_Edit + "' href='javascript:editDescription(" + rowObject.Id + ")' id='description" + rowObject.Id + "' data-text='" + escape(rowObject.Text) + "' class='editlink jqgrid-bootstrap-table-edit' ><i class=\"fa fa-pencil-square-o fa-lg\"></i></a>&nbsp;&nbsp;<a class='deleteLink jqgrid-bootstrap-table-delete' data-toggle='tooltip' title='" + Localization_Delete + "' href='javascript:deleteDescription(\"" + rowObject.Id + "\")' ><i class=\"fa fa-trash-o fa-lg\"></i></a>";
    return actionHtml;
}

function myUserActions(cellValue, options, rowObject) {
    var actionHtml = "<a data-toggle='tooltip' title='" + Localization_Edit + "' href='" + RQ_URL + "/Customers/User/" + rowObject.UserProviderKey + "' class='jqgrid-bootstrap-table-edit' ><i class=\"fa fa-pencil-square-o fa-lg\"></i></a>";
    actionHtml += "&nbsp;&nbsp;<a class='deleteLink jqgrid-bootstrap-table-delete' data-toggle='tooltip' data-fullname='" + rowObject.UserFullName + "' title='" + Localization_Delete + "' href='" + RQ_URL + "/Account/Delete/" + rowObject.UserProviderKey + "'\"><i class=\"fa fa-trash-o fa-lg\"></i></a>";
    actionHtml += "&nbsp;&nbsp;<a data-toggle='tooltip' title='" + Localization_RemoveUserFromCompany + "' href='javascript:removeUserFromCustomer(\"" + rowObject.UserProviderKey + "\")' ><i class=\"fa fa-chain-broken fa-lg\"></i></a>";
    return actionHtml;
}

function formatBool(cellValue, options, rowObject) {
    var boolHtml = "<input type='checkbox' " + (cellValue == false ? "" : "checked='checked'") + " data-userproviderkey='" + rowObject.UserProviderKey + "' class='ticket-tag-checkbox' />";
    return boolHtml;
}

function formatBoolManageOthersTickets(cellValue, options, rowObject) {
    var boolHtml = "<input " + (rowObject.CanAccessOthersTickets == true ? "": "disabled") +" type='checkbox' " + (cellValue == false ? "" : "checked='checked'") + " data-userproviderkey='" + rowObject.UserProviderKey + "' class='ticket-manage-checkbox' />";
    return boolHtml;
}

function formatAvatar(cellValue, options, rowObject) {
    return cellValue;
}

function editDescription(id) {
    $("#description" + id).tooltipBS('hide');
    $("#messageId").val(id);
    window.tinyMCE.get('messageText').setContent(unescape($("#description" + id).attr("data-text")));
    $("#dialog-message").dialog("open");
}

function deleteDescription(id) {
    $("#DeleteDescription").val(id);
    $("#dialog-confirmDeleteDescription").dialog("open");
}

function removeUserFromCustomer(userproviderkey) {
    //$(".deleteLink").tooltipBS('hide');
    $("#DeleteUserProviderKey").val(userproviderkey);
    $("#dialog-confirmRemoveUser").dialog("open");
}

function DeleteAttachment(id) {
    idDeletedItem = id;
    $("#dialog-confirmDelete").dialog({
        buttons: [
            {
                text: Localization_Yes,
                click: function () {
                    $.ajax({
                        url: RQ_URL + "/Customers/DeleteAttachment/" + idDeletedItem,
                        type: "GET",
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        success: function () {
                            $(".deleteLink").tooltipBS('hide');
                            $('#jqGridAttachments').trigger("reloadGrid");
                        },
                        error: function (error) { alert(error.responseText); },
                    });
                    $(this).dialog("close");
                }
            },
            {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });
    $("#dialog-confirmDelete").dialog("open");
}

function formatSize(bytes) {
    if (bytes < 10 * 1024)
        return bytes + "&nbsp;B";
    else if (bytes < 10 * 1024 * 1024)
        return Math.round(bytes / 1024) + "&nbsp;kB";
    else
        return Math.round(bytes / 1024 / 1024) + "&nbsp;MB";
}

function UpdateSummarizationForMessage(count) {
    $("#messagescount").text(count);
}

function UpdateSummarizationForEvents(count) {
    $("#eventscount").text(count);
}

function UpdateSummarizationForCustomerGroups(count) {
    $("#groupscount").text(count);
}

function openDialogIcon() {
    showDeleteButton = $("#customerLogo").attr("data-deletebutton");
    $("#dialogDeleteIconButton").show();
    if (showDeleteButton != "True") {
        $("#dialogDeleteIconButton").hide();
    }
    $("#dialog-upload-icon").dialog("open");
}
function customerUploadLogo() {
    $("#FileValidError").hide();
    $("#FileCustomValidError").hide();
    $("#FileValidSizeError").hide();
    var files = $("#dialogIcon").prop("files");
    //var myID = 3; //uncomment this to make sure the ajax URL works
    if (files.length > 0) {
        if (window.FormData !== undefined) {
            var data = new FormData();
            for (var x = 0; x < files.length; x++) {
                data.append("file" + x, files[x]);
            }
            $("#dialogLoadingFiles").show();

            $.ajax({
                type: "POST",
                url: RQ_URL + '/Customers/UploadIcon/' + customerId,
                contentType: false,
                processData: false,
                data: data,
                success: function (result) {
                    $("#dialogLoadingFiles").hide();
                    if (result.success) {
                        $("#customerLogo").attr("data-deletebutton", "True");
                        $("#dialog-upload-icon").dialog("close");
                        $("#customerLogo i").closest("div").hide();
                        $("#customerLogo div.customer-logo").show();
                        $("#customerLogo div.customer-logo img").attr("src", RQ_URL + "/Customers/GetIcon/" + customerId + "?v" + Math.floor((Math.random() * 100) + 1));
                    }
                    else {
                        $("#FileCustomValidError").html(result.message);
                        $("#FileCustomValidError").show();
                    }
                },
                error: function (xhr, status, p3, p4) {
                    var err = "Error " + " " + status + " " + p3 + " " + p4;
                    if (xhr.responseText && xhr.responseText[0] == "{")
                        err = JSON.parse(xhr.responseText).Message;
                    console.log(err);
                    $("#dialogLoadingFiles").hide();
                    $("#FileValidSizeError").show();
                }
            });
        } else {
            alert("This browser doesn't support HTML5 file uploads!");
        }
    }
    else {
        $("#FileValidError").show();
    }
}

function closeUploadDialog() {
    $("#dialog-upload-icon").dialog("close");
}

function deleteUploadIcon() {
    $.ajax({
        type: "POST",
        url: RQ_URL + '/Customers/DeleteIcon/' + customerId,
        contentType: false,
        processData: false,
        success: function (result) {
            $("#customerLogo").attr("data-deletebutton", "False");
            $("#dialog-upload-icon").dialog("close");

            $("#customerLogo i").closest("div").show();
            $("#customerLogo div.customer-logo").hide();
        },
        error: function (xhr, status, p3, p4) {
            var err = "Error " + " " + status + " " + p3 + " " + p4;
            if (xhr.responseText && xhr.responseText[0] == "{")
                err = JSON.parse(xhr.responseText).Message;
            console.log(err);
        }
    });
}

function ticketIdRefFormat(cellValue, options, rowObject) {
    var subjectHtml = "<a href='" + RQ_URL + "/Tickets/Show/" + rowObject.TicketREF + "'>" + cellValue + "</a>";
    return subjectHtml;
}

function subjectFormat(cellValue, options, rowObject) {
    var subjectHtml = "<a href='" + RQ_URL + "/Tickets/Show/" + rowObject.TicketREF + "'>" + cellValue + "</a>";
    return subjectHtml;
}

function solverFormat(cellValue, options, rowObject) {
    var solverHtml = cellValue != null ? "<a href='javascript:void(0)' class='user-info' data-userproviderkey='" + rowObject.SolverKey + "'>" + cellValue + "</a>" : Localization_WithoutSolver;
    return solverHtml;
}

function submitterFormat(cellValue, options, rowObject) {
    var solverHtml = cellValue != null ? "<a href='javascript:void(0)' class='user-info' data-userproviderkey='" + rowObject.SubmitterKey + "'>" + cellValue + "</a>" : "";
    return solverHtml;
}

function createDateFormat(cellValue, options, rowObject) {
    var createDateHtml = rowObject.CreateDate;
    return createDateHtml;
}

function ticketTypeFormat(cellValue, options, rowObject) {
    var ticketTypeHtml = rowObject.TicketTypeText;
    return ticketTypeHtml;
}

function ticketSummaryStateFormat(cellValue, options, rowObject) {
    var ticketSummaryStateTextHtml = rowObject.TicketSummaryStateText;
    return ticketSummaryStateTextHtml;
}

function reloadTable() {
    $("#Events").html("<div class='loading-32'></div>");
    $.ajax({
        url: RQ_URL + "/Events/ReloadCompanyEvents",
        type: "POST",
        data: JSON.stringify({
            page: page,
            companies: customerId
        }),
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            $("#Events").html(g);
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
            UpdateSummarizationForEvents(totalEventsCount);
        }
    });
}

function SaveCustomerGroups() {
    $.ajax({
        url: RQ_URL + "/Customers/SaveGroupsForCustomer",
        type: "POST",
        data: JSON.stringify({
            groupIds: $("#GroupIds").val(),
            id: customerId
        }),
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            ShowSuccess("Skupiny byly uloženy");
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
            UpdateSummarizationForCustomerGroups($("#GroupIds").val().length);
        }
    });
}